diff --git a/fc-solve/source/.clang-format b/fc-solve/source/.clang-format
index 88fdace50..a7dd68df9 100644
--- a/fc-solve/source/.clang-format
+++ b/fc-solve/source/.clang-format
@@ -4,3 +4,5 @@ AlignAfterOpenBracket: DontAlign
 BreakBeforeBraces: Allman
 IndentWidth:     4
 SortIncludes:    false
+BraceWrapping:
+    AfterExternBlock: false
diff --git a/fc-solve/source/alloc_wrap.h b/fc-solve/source/alloc_wrap.h
index 0b5f5d529..3a52f4b03 100644
--- a/fc-solve/source/alloc_wrap.h
+++ b/fc-solve/source/alloc_wrap.h
@@ -11,7 +11,8 @@
 #pragma once
 
 #ifdef __cplusplus
-extern "C" {
+extern "C"
+{
 #endif
 
 #include <stdlib.h>
diff --git a/fc-solve/source/cl_callback.h b/fc-solve/source/cl_callback.h
index fe3f9a4f8..16a0c9396 100644
--- a/fc-solve/source/cl_callback.h
+++ b/fc-solve/source/cl_callback.h
@@ -245,7 +245,8 @@ static freecell_solver_str_t known_parameters[] = {"-h", "--help",
     "--display-parent-iter", "-sel", "--show-exceeded-limits", "-o", "--output",
     "--reset", "--version", NULL};
 
-typedef enum {
+typedef enum
+{
     SUCCESS = 0,
     ERROR = -1,
 } exit_code_t;
diff --git a/fc-solve/source/dbm_cache.h b/fc-solve/source/dbm_cache.h
index bbe8d6e08..309478e63 100644
--- a/fc-solve/source/dbm_cache.h
+++ b/fc-solve/source/dbm_cache.h
@@ -13,7 +13,8 @@
 #pragma once
 
 #ifdef __cplusplus
-extern "C" {
+extern "C"
+{
 #endif
 
 #include "meta_alloc.h"
@@ -25,39 +26,39 @@ extern "C" {
 #include "dbm_calc_derived_iface.h"
 #include "dbm_lru_cache.h"
 
-static int fc_solve_compare_lru_cache_keys(const void *const void_a,
-    const void *const void_b, void *context GCC_UNUSED)
-{
+    static int fc_solve_compare_lru_cache_keys(const void *const void_a,
+        const void *const void_b, void *context GCC_UNUSED)
+    {
 #define GET_PARAM(p) ((((const fcs_cache_key_info_t *)(p))->key))
-    return memcmp(
-        &(GET_PARAM(void_a)), &(GET_PARAM(void_b)), sizeof(GET_PARAM(void_a)));
+        return memcmp(&(GET_PARAM(void_a)), &(GET_PARAM(void_b)),
+            sizeof(GET_PARAM(void_a)));
 #undef GET_PARAM
-}
+    }
 
-static inline void cache_destroy_key(fcs_cache_key_info_t *cache_key)
-{
-    for (; cache_key; cache_key = RECYCLE_BIN_NEXT(cache_key))
+    static inline void cache_destroy_key(fcs_cache_key_info_t *cache_key)
     {
-        free(cache_key->moves_to_key);
-        cache_key->moves_to_key = NULL;
+        for (; cache_key; cache_key = RECYCLE_BIN_NEXT(cache_key))
+        {
+            free(cache_key->moves_to_key);
+            cache_key->moves_to_key = NULL;
+        }
     }
-}
 
-static inline void cache_destroy(fcs_lru_cache_t *cache)
-{
-    cache_destroy_key(cache->recycle_bin);
-    cache_destroy_key(cache->lowest_pri);
-    fc_solve_kaz_tree_destroy(cache->kaz_tree);
-    fc_solve_compact_allocator_finish(
-        &(cache->states_values_to_keys_allocator));
-}
+    static inline void cache_destroy(fcs_lru_cache_t *cache)
+    {
+        cache_destroy_key(cache->recycle_bin);
+        cache_destroy_key(cache->lowest_pri);
+        fc_solve_kaz_tree_destroy(cache->kaz_tree);
+        fc_solve_compact_allocator_finish(
+            &(cache->states_values_to_keys_allocator));
+    }
 
-static inline void cache_init(fcs_lru_cache_t *const cache,
-    const long max_num_elements_in_cache,
-    fcs_meta_compact_allocator_t *const meta_alloc)
-{
+    static inline void cache_init(fcs_lru_cache_t *const cache,
+        const long max_num_elements_in_cache,
+        fcs_meta_compact_allocator_t *const meta_alloc)
+    {
 #if (FCS_RCS_CACHE_STORAGE == FCS_RCS_CACHE_STORAGE_JUDY)
-    cache->states_values_to_keys_map = ((Pvoid_t)NULL);
+        cache->states_values_to_keys_map = ((Pvoid_t)NULL);
 #elif (FCS_RCS_CACHE_STORAGE == FCS_RCS_CACHE_STORAGE_KAZ_TREE)
     cache->tree_recycle_bin = NULL;
     cache->kaz_tree = fc_solve_kaz_tree_create(fc_solve_compare_lru_cache_keys,
@@ -66,117 +67,117 @@ static inline void cache_init(fcs_lru_cache_t *const cache,
 #error Unknown FCS_RCS_CACHE_STORAGE
 #endif
 
-    fc_solve_compact_allocator_init(
-        &(cache->states_values_to_keys_allocator), meta_alloc);
-    cache->lowest_pri = NULL;
-    cache->highest_pri = NULL;
-    cache->recycle_bin = NULL;
-    cache->count_elements_in_cache = 0;
-    cache->max_num_elements_in_cache = max_num_elements_in_cache;
-}
-
-static inline fcs_bool_t cache_does_key_exist(
-    fcs_lru_cache_t *const cache, fcs_cache_key_t *const key)
-{
-    const fcs_cache_key_info_t to_check = {.key = *key};
-    const dict_key_t existing_key =
-        fc_solve_kaz_tree_lookup_value(cache->kaz_tree, &to_check);
-    if (!existing_key)
-    {
-        return FALSE;
+        fc_solve_compact_allocator_init(
+            &(cache->states_values_to_keys_allocator), meta_alloc);
+        cache->lowest_pri = NULL;
+        cache->highest_pri = NULL;
+        cache->recycle_bin = NULL;
+        cache->count_elements_in_cache = 0;
+        cache->max_num_elements_in_cache = max_num_elements_in_cache;
     }
-    else
-    {
-        /* First - promote this key to the top of the cache. */
-        fcs_cache_key_info_t *const existing =
-            (fcs_cache_key_info_t *)existing_key;
 
-        if (existing->higher_pri)
+    static inline fcs_bool_t cache_does_key_exist(
+        fcs_lru_cache_t *const cache, fcs_cache_key_t *const key)
+    {
+        const fcs_cache_key_info_t to_check = {.key = *key};
+        const dict_key_t existing_key =
+            fc_solve_kaz_tree_lookup_value(cache->kaz_tree, &to_check);
+        if (!existing_key)
         {
-            existing->higher_pri->lower_pri = existing->lower_pri;
-            if (existing->lower_pri)
-            {
-                existing->lower_pri->higher_pri = existing->higher_pri;
-            }
-            else
+            return FALSE;
+        }
+        else
+        {
+            /* First - promote this key to the top of the cache. */
+            fcs_cache_key_info_t *const existing =
+                (fcs_cache_key_info_t *)existing_key;
+
+            if (existing->higher_pri)
             {
-                cache->lowest_pri = existing->higher_pri;
-                /* Bug fix: keep the chain intact. */
-                existing->higher_pri->lower_pri = NULL;
+                existing->higher_pri->lower_pri = existing->lower_pri;
+                if (existing->lower_pri)
+                {
+                    existing->lower_pri->higher_pri = existing->higher_pri;
+                }
+                else
+                {
+                    cache->lowest_pri = existing->higher_pri;
+                    /* Bug fix: keep the chain intact. */
+                    existing->higher_pri->lower_pri = NULL;
+                }
+                cache->highest_pri->higher_pri = existing;
+                existing->lower_pri = cache->highest_pri;
+                cache->highest_pri = existing;
+                existing->higher_pri = NULL;
             }
-            cache->highest_pri->higher_pri = existing;
-            existing->lower_pri = cache->highest_pri;
-            cache->highest_pri = existing;
-            existing->higher_pri = NULL;
-        }
 
-        return TRUE;
+            return TRUE;
+        }
     }
-}
-
-static inline fcs_cache_key_info_t *cache_insert(fcs_lru_cache_t *cache,
-    const fcs_cache_key_t *key, const fcs_fcc_move_t *moves_to_parent,
-    const fcs_fcc_move_t final_move)
-{
-    fcs_cache_key_info_t *cache_key;
-    var_AUTO(kaz_tree, cache->kaz_tree);
 
-    if (cache->count_elements_in_cache >= cache->max_num_elements_in_cache)
+    static inline fcs_cache_key_info_t *cache_insert(fcs_lru_cache_t *cache,
+        const fcs_cache_key_t *key, const fcs_fcc_move_t *moves_to_parent,
+        const fcs_fcc_move_t final_move)
     {
-        fc_solve_kaz_tree_delete_by_value(
-            kaz_tree, (cache_key = cache->lowest_pri));
+        fcs_cache_key_info_t *cache_key;
+        var_AUTO(kaz_tree, cache->kaz_tree);
 
-        cache->lowest_pri = cache->lowest_pri->higher_pri;
-        cache->lowest_pri->lower_pri = NULL;
-    }
-    else
-    {
-        cache_key = (fcs_cache_key_info_t *)fcs_compact_alloc_ptr(
-            &(cache->states_values_to_keys_allocator), sizeof(*cache_key));
-        cache_key->moves_to_key = NULL;
-        ++cache->count_elements_in_cache;
-    }
+        if (cache->count_elements_in_cache >= cache->max_num_elements_in_cache)
+        {
+            fc_solve_kaz_tree_delete_by_value(
+                kaz_tree, (cache_key = cache->lowest_pri));
 
-    cache_key->key = *key;
-    if (moves_to_parent)
-    {
-        fcs_fcc_move_t *moves;
-        const_AUTO(len, strlen((const char *)moves_to_parent));
-        cache_key->moves_to_key = moves =
-            SREALLOC(cache_key->moves_to_key, len + 1 + 1);
-        memcpy(moves, moves_to_parent, len);
-        moves[len] = final_move;
-        moves[len + 1] = '\0';
-    }
-    else if (final_move)
-    {
-        cache_key->moves_to_key = SREALLOC(cache_key->moves_to_key, 2);
-        cache_key->moves_to_key[0] = final_move;
-        cache_key->moves_to_key[1] = '\0';
-    }
-    else
-    {
-        free(cache_key->moves_to_key);
-        cache_key->moves_to_key = NULL;
-    }
+            cache->lowest_pri = cache->lowest_pri->higher_pri;
+            cache->lowest_pri->lower_pri = NULL;
+        }
+        else
+        {
+            cache_key = (fcs_cache_key_info_t *)fcs_compact_alloc_ptr(
+                &(cache->states_values_to_keys_allocator), sizeof(*cache_key));
+            cache_key->moves_to_key = NULL;
+            ++cache->count_elements_in_cache;
+        }
 
-    if (cache->highest_pri)
-    {
-        cache_key->lower_pri = cache->highest_pri;
-        cache_key->higher_pri = NULL;
-        cache->highest_pri->higher_pri = cache_key;
-        cache->highest_pri = cache_key;
-    }
-    else
-    {
-        cache->highest_pri = cache->lowest_pri = cache_key;
-        cache_key->higher_pri = cache_key->lower_pri = NULL;
-    }
+        cache_key->key = *key;
+        if (moves_to_parent)
+        {
+            fcs_fcc_move_t *moves;
+            const_AUTO(len, strlen((const char *)moves_to_parent));
+            cache_key->moves_to_key = moves =
+                SREALLOC(cache_key->moves_to_key, len + 1 + 1);
+            memcpy(moves, moves_to_parent, len);
+            moves[len] = final_move;
+            moves[len + 1] = '\0';
+        }
+        else if (final_move)
+        {
+            cache_key->moves_to_key = SREALLOC(cache_key->moves_to_key, 2);
+            cache_key->moves_to_key[0] = final_move;
+            cache_key->moves_to_key[1] = '\0';
+        }
+        else
+        {
+            free(cache_key->moves_to_key);
+            cache_key->moves_to_key = NULL;
+        }
 
-    fc_solve_kaz_tree_alloc_insert(kaz_tree, cache_key);
+        if (cache->highest_pri)
+        {
+            cache_key->lower_pri = cache->highest_pri;
+            cache_key->higher_pri = NULL;
+            cache->highest_pri->higher_pri = cache_key;
+            cache->highest_pri = cache_key;
+        }
+        else
+        {
+            cache->highest_pri = cache->lowest_pri = cache_key;
+            cache_key->higher_pri = cache_key->lower_pri = NULL;
+        }
 
-    return cache_key;
-}
+        fc_solve_kaz_tree_alloc_insert(kaz_tree, cache_key);
+
+        return cache_key;
+    }
 
 #ifdef __cplusplus
 }
diff --git a/fc-solve/source/dbm_calc_derived.h b/fc-solve/source/dbm_calc_derived.h
index f50b17cf1..579f90728 100644
--- a/fc-solve/source/dbm_calc_derived.h
+++ b/fc-solve/source/dbm_calc_derived.h
@@ -14,7 +14,8 @@
 #pragma once
 
 #ifdef __cplusplus
-extern "C" {
+extern "C"
+{
 #endif
 
 #include "meta_alloc.h"
@@ -26,35 +27,35 @@ extern "C" {
 #include "indirect_buffer.h"
 #include "fcc_brfs_test.h"
 
-typedef struct fcs_derived_state_struct
-{
-    fcs_state_keyval_pair_t state;
-    fcs_encoded_state_buffer_t key;
-    fcs_dbm_record_t *parent;
-    struct fcs_derived_state_struct *next;
-    int core_irreversible_moves_count;
-    fcs_which_moves_bitmask_t which_irreversible_moves_bitmask;
-    fcs_fcc_move_t move;
-    int num_non_reversible_moves_including_prune;
-    DECLARE_IND_BUF_T(indirect_stacks_buffer)
-} fcs_derived_state_t;
-
-static inline void fcs_derived_state_list__recycle(
-    fcs_derived_state_t **const p_recycle_bin,
-    fcs_derived_state_t **const p_list)
-{
-    var_AUTO(list, *p_list);
-    var_AUTO(bin, *p_recycle_bin);
-    while (list)
+    typedef struct fcs_derived_state_struct
     {
-        var_AUTO(list_next, list->next);
-        list->next = bin;
-        bin = list;
-        list = list_next;
+        fcs_state_keyval_pair_t state;
+        fcs_encoded_state_buffer_t key;
+        fcs_dbm_record_t *parent;
+        struct fcs_derived_state_struct *next;
+        int core_irreversible_moves_count;
+        fcs_which_moves_bitmask_t which_irreversible_moves_bitmask;
+        fcs_fcc_move_t move;
+        int num_non_reversible_moves_including_prune;
+        DECLARE_IND_BUF_T(indirect_stacks_buffer)
+    } fcs_derived_state_t;
+
+    static inline void fcs_derived_state_list__recycle(
+        fcs_derived_state_t **const p_recycle_bin,
+        fcs_derived_state_t **const p_list)
+    {
+        var_AUTO(list, *p_list);
+        var_AUTO(bin, *p_recycle_bin);
+        while (list)
+        {
+            var_AUTO(list_next, list->next);
+            list->next = bin;
+            bin = list;
+            list = list_next;
+        }
+        *p_recycle_bin = bin;
+        *p_list = NULL;
     }
-    *p_recycle_bin = bin;
-    *p_list = NULL;
-}
 
 #define MAKE_MOVE(src, dest) ((fcs_fcc_move_t)((src) | ((dest) << 4)))
 #define COL2MOVE(idx) (idx)
@@ -103,18 +104,18 @@ static inline void fcs_derived_state_list__recycle(
         COPY_INDIRECT_COLS()                                                   \
     }
 
-static inline void fc_solve_add_to_irrev_moves_bitmask(
-    fcs_which_moves_bitmask_t *const which_irreversible_moves_bitmask,
-    const fcs_card_t moved_card, const int count)
-{
-    unsigned char *const by_rank_ptr =
-        which_irreversible_moves_bitmask->s + fcs_card_rank(moved_card) - 1;
-    const int suit_times_two = (fcs_card_suit(moved_card) << 1);
-    const int new_count =
-        ((((*by_rank_ptr) >> (suit_times_two)) & ((1 << 2) - 1)) + count);
-    *by_rank_ptr &= (~((((unsigned char)0x3) << (suit_times_two))));
-    *by_rank_ptr |= (new_count << (suit_times_two));
-}
+    static inline void fc_solve_add_to_irrev_moves_bitmask(
+        fcs_which_moves_bitmask_t *const which_irreversible_moves_bitmask,
+        const fcs_card_t moved_card, const int count)
+    {
+        unsigned char *const by_rank_ptr =
+            which_irreversible_moves_bitmask->s + fcs_card_rank(moved_card) - 1;
+        const int suit_times_two = (fcs_card_suit(moved_card) << 1);
+        const int new_count =
+            ((((*by_rank_ptr) >> (suit_times_two)) & ((1 << 2) - 1)) + count);
+        *by_rank_ptr &= (~((((unsigned char)0x3) << (suit_times_two))));
+        *by_rank_ptr |= (new_count << (suit_times_two));
+    }
 
 #define COMMIT_NEW_STATE_WITH_COUNT(src, dest, count, moved_card)              \
     {                                                                          \
@@ -138,64 +139,66 @@ static inline void fc_solve_add_to_irrev_moves_bitmask(
     COMMIT_NEW_STATE_WITH_COUNT(                                               \
         src, dest, ((is_reversible) ? 0 : 1), moved_card)
 
-static inline __attribute__((pure)) int calc_foundation_to_put_card_on(
-    const fcs_dbm_variant_type_t local_variant, fcs_state_t *const ptr_state,
-    const fcs_card_t card)
-{
+    static inline __attribute__((pure)) int calc_foundation_to_put_card_on(
+        const fcs_dbm_variant_type_t local_variant,
+        fcs_state_t *const ptr_state, const fcs_card_t card)
+    {
 #ifndef FCS_FREECELL_ONLY
-    const int sequences_are_built_by = CALC_SEQUENCES_ARE_BUILT_BY();
+        const int sequences_are_built_by = CALC_SEQUENCES_ARE_BUILT_BY();
 #endif
-    const int_fast32_t rank = fcs_card_rank(card);
-    const int_fast32_t suit = fcs_card_suit(card);
-    for (uint_fast32_t deck = 0; deck < INSTANCE_DECKS_NUM; ++deck)
-    {
-        if (fcs_foundation_value(*ptr_state, (deck << 2) + suit) == rank - 1)
+        const int_fast32_t rank = fcs_card_rank(card);
+        const int_fast32_t suit = fcs_card_suit(card);
+        for (uint_fast32_t deck = 0; deck < INSTANCE_DECKS_NUM; ++deck)
         {
-            uint_fast32_t other_deck_idx;
-
-            for (other_deck_idx = 0; other_deck_idx < (INSTANCE_DECKS_NUM << 2);
-                 ++other_deck_idx)
+            if (fcs_foundation_value(*ptr_state, (deck << 2) + suit) ==
+                rank - 1)
             {
-                if (fcs_foundation_value(*ptr_state, other_deck_idx) <
-                    rank - 2 -
-                        (FCS__SEQS_ARE_BUILT_BY_RANK()
-                                ? 0
-                                : ((other_deck_idx & 0x1) == (suit & 0x1))))
+                uint_fast32_t other_deck_idx;
+
+                for (other_deck_idx = 0;
+                     other_deck_idx < (INSTANCE_DECKS_NUM << 2);
+                     ++other_deck_idx)
                 {
-                    break;
+                    if (fcs_foundation_value(*ptr_state, other_deck_idx) <
+                        rank - 2 -
+                            (FCS__SEQS_ARE_BUILT_BY_RANK()
+                                    ? 0
+                                    : ((other_deck_idx & 0x1) == (suit & 0x1))))
+                    {
+                        break;
+                    }
+                }
+                if (other_deck_idx == (INSTANCE_DECKS_NUM << 2))
+                {
+                    return (deck << 2) + suit;
                 }
-            }
-            if (other_deck_idx == (INSTANCE_DECKS_NUM << 2))
-            {
-                return (deck << 2) + suit;
             }
         }
+        return -1;
     }
-    return -1;
-}
-
-typedef struct
-{
-    fcs_fcc_moves_list_item_t *recycle_bin;
-    fcs_compact_allocator_t *allocator;
-} fcs_fcc_moves_seq_allocator_t;
 
-static inline fcs_fcc_moves_list_item_t *fc_solve_fcc_alloc_moves_list_item(
-    fcs_fcc_moves_seq_allocator_t *const allocator)
-{
-    fcs_fcc_moves_list_item_t *new_item;
-    if (allocator->recycle_bin)
+    typedef struct
     {
-        allocator->recycle_bin = (new_item = allocator->recycle_bin)->next;
-    }
-    else
+        fcs_fcc_moves_list_item_t *recycle_bin;
+        fcs_compact_allocator_t *allocator;
+    } fcs_fcc_moves_seq_allocator_t;
+
+    static inline fcs_fcc_moves_list_item_t *fc_solve_fcc_alloc_moves_list_item(
+        fcs_fcc_moves_seq_allocator_t *const allocator)
     {
-        new_item = (fcs_fcc_moves_list_item_t *)fcs_compact_alloc_ptr(
-            allocator->allocator, sizeof(*new_item));
+        fcs_fcc_moves_list_item_t *new_item;
+        if (allocator->recycle_bin)
+        {
+            allocator->recycle_bin = (new_item = allocator->recycle_bin)->next;
+        }
+        else
+        {
+            new_item = (fcs_fcc_moves_list_item_t *)fcs_compact_alloc_ptr(
+                allocator->allocator, sizeof(*new_item));
+        }
+        new_item->next = NULL;
+        return new_item;
     }
-    new_item->next = NULL;
-    return new_item;
-}
 
 #define FROM_COL_IS_REVERSIBLE_MOVE()                                          \
     ((cards_num <= 1)                                                          \
